﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using TECHIS.Core.Configuration;

namespace TECHIS.Cloud.Configuration.Test
{
    [TestClass]
    public class ConfigurationObjectReaderTests
    {

        [TestMethod]
        public void GetJsonData()
        {
            GetData(DataFormats.Json);
        }
        [TestMethod]
        public void GetXmlData()
        {
            GetData(DataFormats.Json);
        }
        [TestMethod]
        public void GetDefaultData()
        {
            GetData(DataFormats.Json);
        }



        private void GetData(DataFormats? format = null)
        {
            var cr = new ConfigurationObjectReader();

            if (format.HasValue)
            {
                cr.MandatoryFormat = format;
            }

            Types.SampleConfiguration result = cr.GetData<Types.SampleConfiguration>();

            Assert.AreNotEqual(null, result, "GetData should return deserialized object");
            Assert.AreNotEqual(null, result.Name, "The Name property of deserialized object shouldn't be null");
            Assert.AreNotEqual(0, result.Name.Length, "The Name property of deserialized object shouldn't be an empty string");
        }
    }
}
